diff --git a/src/backend/access/heap/visibilitymap.c b/src/backend/access/heap/visibilitymap.c
index 919e8de..a7a6de2 100644
--- a/src/backend/access/heap/visibilitymap.c
+++ b/src/backend/access/heap/visibilitymap.c
@@ -303,7 +303,7 @@ visibilitymap_test(Relation rel, BlockNumber heapBlk, Buffer *buf)
 #endif
 
 	/* Reuse the old pinned buffer if possible */
-	if (BufferIsValid(*buf))
+	if (!BufferIsInvalid(*buf))
 	{
 		if (BufferGetBlockNumber(*buf) != mapBlock)
 		{
@@ -312,10 +312,10 @@ visibilitymap_test(Relation rel, BlockNumber heapBlk, Buffer *buf)
 		}
 	}
 
-	if (!BufferIsValid(*buf))
+	if (BufferIsInvalid(*buf))
 	{
 		*buf = vm_readbuf(rel, mapBlock, false);
-		if (!BufferIsValid(*buf))
+		if (BufferIsInvalid(*buf))
 			return false;
 	}
 
